Option Strict Off
Option Explicit On 

Imports Microsoft.VisualBasic
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System
Imports System.ComponentModel
Imports System.Data
Imports System.Data.Common
Imports System.Drawing
Imports System.Globalization
Imports System.Windows.Forms
Imports System.IO
Imports System.Collections.Specialized

Public Class Form1
    Inherits Form


    Private nia_tx As DataSet
    Private WithEvents phraseGrid1 As GridHierDataBoundGrid
    Private WithEvents elementGrid2 As GridHierDataBoundGrid
    Private WithEvents correctionGrid3 As GridDataBoundGrid

    Private components As Container
    'Fields
    'Constructors
    'Events
    'Methods
    Public Sub New()
        MyBase.New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()
        '
        ' TODO: Add any constructor code after InitializeComponent call
        '

    End Sub
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)

        If disposing Then
            If (Not (components) Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)

    End Sub
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents stICE As System.Windows.Forms.StatusBar
    Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.stICE = New System.Windows.Forms.StatusBar
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem4, Me.MenuItem5})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem2, Me.MenuItem3})
        Me.MenuItem1.Text = "File"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 0
        Me.MenuItem2.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.MenuItem2.Text = "Open"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 1
        Me.MenuItem3.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.MenuItem3.Text = "Save"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 1
        Me.MenuItem4.Text = "Reports"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 2
        Me.MenuItem5.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem6})
        Me.MenuItem5.Text = "Help"
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 0
        Me.MenuItem6.Text = "About"
        '
        'stICE
        '
        Me.stICE.Location = New System.Drawing.Point(0, 478)
        Me.stICE.Name = "stICE"
        Me.stICE.Size = New System.Drawing.Size(800, 22)
        Me.stICE.TabIndex = 0
        Me.stICE.Text = "Status"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.ActiveBorder
        Me.ClientSize = New System.Drawing.Size(800, 500)
        Me.Controls.Add(Me.stICE)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.ResumeLayout(False)

    End Sub
    <STAThread()> _
    Public Shared Sub Main()

        Application.Run(New Form1)

    End Sub
    Private Sub FillGrid()
        ' products - used for foreign key griddropdownlist
        'inner most grid ... does not contain dropdowns - so it is a GridDataBoundGrid
        ' will be shown in dropdown

        If Me.correctionGrid3 Is Nothing Then
        Else
            Me.correctionGrid3.Dispose()
        End If

        Me.correctionGrid3 = New GridHierDataBoundGrid(Me, nia_tx.Tables("Corrections"), Nothing, Nothing, Nothing, Nothing, False)
        Me.correctionGrid3.Model.HideCols("Created") = False
        Me.correctionGrid3.Model.HideCols("Updated") = False
        Me.correctionGrid3.Model.HideCols("Phrase_Id") = True
        Me.correctionGrid3.Model.HideCols("Created_By") = False
        Me.correctionGrid3.Model.HideCols("Updated_By") = False

        ' Dim _y As GridCurrentCellShowingDropDownEventHandler = New GridCurrentCellShowingDropDownEventHandler(AddressOf correctionGrid3_CurrentCellShowingDropDown)
        ' AddHandler correctionGrid3.CurrentCellShowingDropDown, _y

        'setorder_DetailsGridLooks(this, EventArgs.Empty); //force the first setting...
        'this.order_DetailsGrid3.Model.DataProviderChanged += new EventHandler(setorder_DetailsGridLooks);
        'this.order_DetailsGrid3.Model.DataProviderChanged += new EventHandler(setorder_DetailsGridLooks);
        'in code, create a grid for the orders table - uses GridHierDataBoundGrid class
        ' - will be shown in dropdown

        If Me.elementGrid2 Is Nothing Then
        Else
            Me.elementGrid2.Dispose()
        End If

        Me.elementGrid2 = New GridHierDataBoundGrid(Me, nia_tx.Tables("Elements"), nia_tx.Tables("Corrections"), correctionGrid3, New QueryFilterStringEventHandler(AddressOf ProvideOrder_DetailsFilterStrings), New QueryFormatGridEventHandler(AddressOf ProvideOrder_DetailsFormat), True)
        Me.elementGrid2.Model.HideCols("Created") = True
        Me.elementGrid2.Model.HideCols("Updated") = True
        Me.elementGrid2.Model.HideCols("Created_By") = True
        Me.elementGrid2.Model.HideCols("Phrase_Id") = True
        Me.elementGrid2.Model.HideCols("Element_Id") = True
        Me.elementGrid2.Model.HideCols("Updated_By") = True

        Dim _x As GridCurrentCellShowingDropDownEventHandler = New GridCurrentCellShowingDropDownEventHandler(AddressOf elementGrid2_CurrentCellShowingDropDown)
        AddHandler elementGrid2.CurrentCellShowingDropDown, _x

        ' elementGrid2.Model.ColWidths.ResizeToFit(elementGrid2.Model.GridCellsRange)
        'setOrderGridLooks(this, EventArgs.Empty);//force the first setting...
        'this.orderGrid2.Model.DataProviderChanged += new EventHandler(setOrderGridLooks);
        'create the outer most grid for the customers table - uses GridHierDataBoundGrid class

        If Me.phraseGrid1 Is Nothing Then
        Else
            Me.phraseGrid1.Dispose()
        End If

        Me.phraseGrid1 = New GridHierDataBoundGrid(Me, nia_tx.Tables("Phrases"), nia_tx.Tables("Elements"), Me.elementGrid2, New QueryFilterStringEventHandler(AddressOf ProvideOrdersFilterStrings), New QueryFormatGridEventHandler(AddressOf ProvideOrderFormat), True)

        'set its properties....
        Me.phraseGrid1.ThemesEnabled = True
        Me.phraseGrid1.Location = New Point(20, 20)
        Me.phraseGrid1.Size = New Size((Me.ClientSize.Width - 40), (Me.ClientSize.Height - 40))
        Me.phraseGrid1.Anchor = (((AnchorStyles.Bottom Or AnchorStyles.Left) _
                     Or AnchorStyles.Right) _
                     Or AnchorStyles.Top)

        Me.phraseGrid1.BorderStyle = BorderStyle.Fixed3D


        ' Me.phraseGrid1.BaseStylesMap("Header").StyleInfo.BackColor = Color.FromArgb(100, 100, 255)
        Me.phraseGrid1.BaseStylesMap("Header").StyleInfo.BackColor = Color.FromKnownColor(KnownColor.ActiveCaption)
        Me.phraseGrid1.BaseStylesMap("Header").StyleInfo.TextColor = Color.FromKnownColor(KnownColor.ActiveCaptionText)
        ' Me.phraseGrid1.BaseStylesMap("Header").StyleInfo.TextColor = Color.LightBlue
        Me.phraseGrid1.TableStyle.BackColor = Color.White
        Me.phraseGrid1.Model.ColWidths.ResizeToFit(phraseGrid1.Model.GridCellsRange)
        Me.phraseGrid1.Model.HideCols("Created") = True
        Me.phraseGrid1.Model.HideCols("Updated") = True
        Me.phraseGrid1.Model.HideCols("Phrase_Id") = True
        Me.phraseGrid1.Model.HideCols("Block_Id") = True
        Me.phraseGrid1.Model.HideCols("Created_By") = True
        Me.phraseGrid1.Model.HideCols("Updated_By") = True
        Me.phraseGrid1.EnableAddNew = False
        Me.Controls.Add(Me.phraseGrid1)

        ' Hide Columns Section

        phraseGrid1.CurrentCell.Deactivate(True)

        'this.phraseGrid1.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.SetCurrent;

        Me.phraseGrid1.CurrentCell.Activate(1, 2, GridSetCurrentCellOptions.SetFocus)
        '**
        Me.phraseGrid1.GridBoundColumns("Source").StyleInfo.ReadOnly = True


    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub
    Private Sub ProvideOrderFormat(ByVal sender As Object, ByVal e As QueryFormatGridEventArgs)
        e.Grid.Model.BaseStylesMap("Header").StyleInfo.BackColor = Color.FromKnownColor(KnownColor.ActiveCaption)
        e.Grid.Model.BaseStylesMap("Header").StyleInfo.TextColor = Color.FromKnownColor(KnownColor.ActiveCaptionText)
        e.Grid.Model.TableStyle.BackColor = Color.White
        Dim style As GridStyleInfo
        style = CType(e.Grid, GridDataBoundGrid).GridBoundColumns("Target").StyleInfo
        style.CellType = "ComboBox"
        style.DataSource = nia_tx.Tables("Leverage")
        style.ValueMember = "Leverage_Id"
        style.DisplayMember = "Target"
        style.DropDownStyle = GridDropDownStyle.Editable

        '**
        Dim Items As New StringCollection
        Items.Add("Masculine")
        Items.Add("Feminine")
        Items.Add("Neuter")

        style = CType(e.Grid, GridDataBoundGrid).GridBoundColumns("Gender").StyleInfo
        style.CellType = "ComboBox"
        style.ChoiceList = Items
        'style.ExclusiveChoiceList = True


    End Sub
    Private Sub elementGrid2_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As GridCurrentCellShowingDropDownEventArgs)
        Dim cc As GridCurrentCell = Me.elementGrid2.CurrentCell
        If (cc.ColIndex = 3) Then
            Dim element_id As GridStyleInfo = Me.elementGrid2.Item(cc.RowIndex, 13)
            Dim cr As GridComboBoxCellRenderer = cc.Renderer
            If cr Is Nothing Then
            Else
                Dim dv As DataView = New DataView(nia_tx.Tables("Leverage"), "Element_Id =" & CType(element_id.CellValue, String), "", DataViewRowState.CurrentRows)
                cr.ListBoxPart.DataSource = dv
            End If
        End If

        '**
        'If (cc.ColIndex = 14) Then
        '    Dim element_id As GridStyleInfo = Me.elementGrid2.Item(cc.RowIndex, 13)
        '    Dim cr As GridComboBoxCellRenderer = cc.Renderer
        '    If cr Is Nothing Then
        '    Else
        '        Dim dv As DataView = New DataView(nia_tx.Tables("Leverage"), "Element_Id =" & CType(element_id.CellValue, String), "", DataViewRowState.CurrentRows)
        '        cr.ListBoxPart.DataSource = dv
        '    End If
        'End If

    End Sub
    Private Sub correctionGrid3_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As GridCurrentCellShowingDropDownEventArgs)
        Dim cc As GridCurrentCell = Me.correctionGrid3.CurrentCell
        If (cc.ColIndex = 1) Then
            Dim phrase_id As GridStyleInfo = Me.correctionGrid3.Item(cc.RowIndex, 8)
            Dim cr As GridComboBoxCellRenderer = cc.Renderer
            If cr Is Nothing Then
            Else
                Dim dv As DataView = New DataView(nia_tx.Tables("Corrections"), "Phrase_Id =" & CType(phrase_id.CellValue, String), "", DataViewRowState.CurrentRows)
                cr.ListBoxPart.DataSource = dv
            End If
        End If
    End Sub

    Private Sub ProvideOrder_DetailsFormat(ByVal sender As Object, ByVal e As QueryFormatGridEventArgs)
        e.Grid.Model.BaseStylesMap("Header").StyleInfo.BackColor = Color.FromKnownColor(KnownColor.ActiveCaption)
        e.Grid.Model.BaseStylesMap("Header").StyleInfo.TextColor = Color.FromKnownColor(KnownColor.ActiveCaptionText)
        e.Grid.Model.TableStyle.BackColor = Color.White
        ' Dim style As GridStyleInfo
        ' style = CType(e.Grid, GridDataBoundGrid).GridBoundColumns("Target").StyleInfo
        ' style.CellType = "GridHierDataBoundGrid"
        ' style.DataSource = Me.nia_tx.Leverage
        ' style.ValueMember = "Leverage_Id"
        ' style.DisplayMember = "Target"
        ' style.ExclusiveChoiceList = True
    End Sub
    Private Sub ProvideOrdersFilterStrings(ByVal sender As Object, ByVal e As QueryFilterStringEventArgs)
        If (Me.phraseGrid1.Model(e.Row, (e.Column + 5)).Text = "") Then
            e.FilterString = "Phrase_Id = '0'"
        Else
            e.FilterString = System.String.Format("Phrase_Id = '{0}'", Me.phraseGrid1.Model(e.Row, (e.Column + 5)).Text)
        End If
    End Sub
    Private Sub ProvideOrder_DetailsFilterStrings(ByVal sender As Object, ByVal e As QueryFilterStringEventArgs)
        'add 1 to get to phrase id integer
        If (Me.elementGrid2.Model(e.Row, (e.Column + 9)).Text = "") Then
            e.FilterString = "Phrase_Id = '0'"
        Else
            e.FilterString = System.String.Format("Phrase_Id = '{0}'", Me.elementGrid2.Model(e.Row, (e.Column + 9)).Text)
        End If
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        If nia_tx Is Nothing Then
            nia_tx = New DataSet
            nia_tx.ReadXmlSchema("nia_translation_exchange.xsd")
            Try
                nia_tx.ReadXml("c:\test_ice.xml")
            Catch ex As Exception
                Dim _x As String = ex.ToString
            End Try
        End If

        stICE.Text = ""
        stICE.Width = stICE.Text.Length
        FillGrid()
    End Sub

    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        nia_tx.WriteXml("translations.xml")
        stICE.Text = ""
    End Sub
End Class